/**
  Matematicianul Blaise Pascal s-a ocupat de studiul combinatoricii.

  La un moment dat a demonstrat faptul că numărul de combinări se poate
deduce recurent pe baza formulei:
C(n,k) = C(n-1,k)+C(n-1,k-1)
unde C(n,k) = combinări de n luate câte k = numărul de submulțimi cu EXACT
                      k elemente ale unei mulțimi cu n elemente.
De exemplu, C(5,3)=10
(iată cum arată combinările de 3 ale mulțimii {1,2,3,4,5}:
 {1,2,3}   {2,3,4}   {3,4,5}
 {1,2,4}   {2,3,5}
 {1,2,5}   {2,4,5}
 {1,3,4}
 {1,3,5}
 {1,4,5}

Formula găsită de Pascal se poate foarte ușor implementa cu matrici, gândindu-ne
pur și simplu că C(n,k) este un element dintr-o matrice, aflat pe linia n și coloana k.
 However, formula fiind recurentă, avem nevoie de niște valori inițiale:
C(0,0) = 1
C(q,0) = 1
C(q,q) = 1

Formulele ne obligă de data aceasta să lucrăm de la 0.
Dat fiind că formula are sens DOAR dacă k<=n (combinări de n luate cîte k)
o jumătate de matrice rămâne necompletată.
Mai precis, pe diagonala principală (elementele care sunt de forma a[i][i]) avem
1 și în dreapta ei elementele nu ne interesează (le putem lăsa 0 dacă inițializăm
matricea cu 0)
Ex:
Iată cum arată triunghiul lui Pascal pt. n=6
(deci are 7 linii și coloane pt. că începem de la 0)
1
1 1
1 2  1
1 3  3  1
1 4  6  4  1
1 5 10 10  5  1
1 6 15 20 15  6 1
1 7 21 35 35 21 7 1

Schematic, pe fiecare linie primul element este egal cu 1, ultimul este egal cu 1
și între ele orice element este suma dintre cel de deasupra și cel din stânga

Aplicație:
  citim n natural, maxmimum 20. Să generăm și afișăm triunghiul lui Pascal
pentru acest n (deci n+1 linii).
   Să-l afișăm, doar partea de până la diagonala principală.
*/
#include <bits/stdc++.h>
using namespace std;

int main()
{

    int a[21][21];
    int n,i,j;
    cin>>n;
    for(i=0;i<=n;i++)
    {
        a[i][0]=a[i][i]=1;///primul și ultimul element le facem 1
        for(j=1;j<=i-1;j++)///și la cele dintre aplicăm formula:
           a[i][j]=a[i-1][j]+a[i-1][j-1];
    }
    for(i=0;i<=n;i++)
    {
        for(j=0;j<=i;j++)
            cout<<setw(7)<<a[i][j];
        cout<<"\n";
    }
    return 0;


}
